/*=============================================================================

    This file is part of FLINT.

    FLINT is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FLINT is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FLINT; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

=============================================================================*/
/******************************************************************************

    Copyright (C) 2010 William Hart
    Copyright (C) 2010 Fredrik Johansson

******************************************************************************/

#include <stdlib.h>
#include <gmp.h>
#include "flint.h"
#include "hmod_mat.h"

void
hmod_mat_init_set(hmod_mat_t mat, const hmod_mat_t src)
{
    long rows = src->r;
    long cols = src->c;

    if ((rows) && (cols))
    {
        long i, j;
        mat->entries = flint_malloc(rows * cols * sizeof(hlimb_t));
        mat->rows = flint_malloc(rows * sizeof(hlimb_t *));

        for (i = 0; i < rows; i++)
        {
            mat->rows[i] = mat->entries + i * cols;
            for (j = 0; j < cols; j++)
                mat->rows[i][j] = src->rows[i][j];
        }
    }
    else
        mat->entries = NULL;

    mat->r = rows;
    mat->c = cols;

    mat->mod = src->mod;
}
